require_dependency 'repository'

module ScmRepositoryPatch

  def self.included(base)
    base.send(:include, InstanceMethods)
    base.class_eval do
      unloadable

      before_destroy :remove_repository_files
    end
  end

  module InstanceMethods

    def remove_repository_files
      interface = SCMCreator.interface(self)
      if interface
        interface.execute(ScmConfig['pre_delete'], self.root_url, project) if ScmConfig['pre_delete']
        interface.delete_repository(self.root_url)
        interface.execute(ScmConfig['post_delete'], self.root_url, project) if ScmConfig['post_delete']
      end
    end
  end
end
